<?php
/*
 * @Author: wang jun
 * @Date: 2021-11-16 11:27:46
 * @Last Modified by: wang jun
 * @Last Modified time: 2021-11-18 17:56:34
 */
namespace app\admin\logic;

use app\admin\model\webuserlogmodel;
use app\admin\model\webusermodel;
use think\Request;

class webuserloglogic
{
    //加日志信息
    public function addlog($arr)
    {
        $insertData = [];
        $m_wu = new webusermodel();
        $ip = Request::instance()->ip();
        $insertData = [
            'ip' => $ip,
            'createtime' => date('Y-m-d H:i:s'),
        ];
        $where = [];
        if (isset($arr['token']) && !empty($arr['token'])) {
            $token = $arr['token'];
            $where['token'] = $token;
        }

        if (isset($arr['wuid']) && !empty($arr['wuid']) && !isset($insertData['wuid'])) {
            $id = $arr['wuid'];
            $where['id'] = $id;
        }
        $info = $m_wu->getInfo($where, ['id']);
        if (empty($info)) {
            return backarr(0, "无用户数据");
        }
        $insertData['wuid'] = $info['id'];
        if (isset($arr['node']) && !empty($arr['node'])) {
            $insertData['node'] = $arr['node'];
        }
        if (isset($arr['type']) && !empty($arr['type'])) {
            $insertData['type'] = $arr['type'];
        }
        if (isset($arr['tablename']) && !empty($arr['tablename'])) {
            $insertData['tablename'] = $arr['tablename'];
        }
        if (isset($arr['refid']) && !empty($arr['refid'])) {
            $insertData['refid'] = $arr['refid'];
        }
        $m_wul = new webuserlogmodel();
        $id = $m_wul->insertData($insertData);
        if ($id <= 0) {
            return backarr(0, "操作失败");
        }
        return backarr(1, "操作成功");
    }
    /***
     * 获取列表
     * 20211221
     * wj
     */
    public function getlistbywhere($arr)
    {
        $m_wl = new webuserlogmodel();
        $m_wu = new webusermodel();
        $userlist = [];
        $where = [];
        if (isset($arr['type']) && !empty($arr['type'])) {
            $type = explode(',', $arr['type']);
            $where['type'] = ['in', $type];
        }
        if (isset($arr['refid']) && !empty($arr['refid']) && is_numeric($arr['refid'])) {
            $where['refid'] = $arr['refid'];
        }
        $page = isset($arr['page']) && !empty($arr['page']) ? $arr['page'] : 1;
        $size = isset($arr['size']) && !empty($arr['size']) ? $arr['size'] : 10;
        $count = $m_wl->getList($where, 'count');
        if ($count <= 0) {
            return backarr(0, "无数据");
        }
        $field = ['id', 'wuid', 'ip', 'node', 'createtime', 'type', 'refid'];
        $list = $m_wl->getList($where, $field, $page, $size);
        foreach ($list as $key => &$value) {
            if (isset($userlist[$value['wuid']])) {
                $wuinfo = $userlist[$value['wuid']];
            } else {
                $wuinfo = $m_wu->getInfo(['id' => $value['wuid']], 'user_name');
                $userlist[$value['wuid']] = $wuinfo;
            }
            $list[$key]['username'] = $wuinfo['user_name'];
        }
        $data = [
            'count' => $count,
            'list' => $list,
        ];
        return backarr(1, "查询成功", $data);
    }
}
