<?php
/*
 * @Author: wang jun
 * @Date: 2022-01-18 11:12:23
 * @Last Modified by: wang jun
 * @Last Modified time: 2022-01-19 15:48:53
 * 微信类
 */
namespace app\index\logic;

use app\index\model\usermodel;

class userlogic extends baselogic
{
    /**
     * 设置请求数据规则
     * 20220107
     * wj
     */
    protected function setrules()
    {
        $list = [
            'newinfo' => [
                ['name' => 'openid', 'title' => 'openid', 'require' => true, 'type' => 'string'],
            ],
            'realauthbyopenid' => [
                ['name' => 'openid', 'title' => 'openid', 'require' => true, 'type' => 'string'],
            ],
            'updateiscompanybyopenid' => [
                ['name' => 'openid', 'title' => 'openid', 'require' => true, 'type' => 'string'],
            ],
            'getfieldbyopenid' => [
                ['name' => 'openid', 'title' => 'openid', 'require' => true, 'type' => 'string'],
            ],
            'getfieldbyid' => [
                ['name' => 'userid', 'title' => 'userid', 'require' => true, 'type' => 'string'],
            ],
        ];
        return $list;
    }
    /**
     * 新建用户
     * wj
     * 20220118
     */
    public function newinfo($arr)
    {
        $result = $this->checkparam(__FUNCTION__, $arr);
        if (1 != $result['status']) {
            return $result;
        }
        $openid = $arr['openid'];
        $m_u = new usermodel();
        $uinfo = $m_u->getinfobyopenid($openid);
        if (!empty($uinfo)) {
            $id = $uinfo['id'];
        } else {
            $id = $m_u->insertData($arr);
        }
        if (empty($id)) {
            return backarr(0, "新增失败");
        }
        return backarr(1, "新增成功", ['id' => $id]);
    }
    /**
     * 实名认证
     * wj
     * 20220118
     */
    public function realauthbyopenid($arr)
    {
        $result = $this->checkparam(__FUNCTION__, $arr);
        if (1 != $result['status']) {
            return $result;
        }
        $openid = $arr['openid'];
        $m_u = new usermodel();
        $info = $m_u->getinfobyopenid($openid);
        if (empty($info)) {
            return backarr(0, '无用户');
        }
        $id = $info['id'];
        if (isset($arr['sfzid']) && !empty($arr['sfzid']) && is_string($arr['sfzid'])) {
            $sfzid = $arr['sfzid'];
            if ($info['sfzid'] != $sfzid) {
                $hassfzid = $this->hassfzid($sfzid);
                if ($hassfzid) {
                    return backarr(0, '身份证已存在');
                }
            }
        }
        if (isset($arr['telno']) && !empty($arr['telno']) && is_string($arr['telno'])) {
            if (!isMoblid($arr['telno'])) {
                return backarr(0, '手机号格式错误');
            }
            $telno = $arr['telno'];
            if ($info['telno'] != $telno) {
                $hastelno = $this->hastelno($telno);
                if ($hastelno) {
                    return backarr(0, '手机号已存在');
                }
            }
        }
        $updateField = ['user_name', 'telno', 'age', 'gender', 'sfzid', 'email', 'address', 'nation', 'origin'];
        $updateData = [];
        foreach ($updateField as $key => $value) {
            if (isset($arr[$value])) {
                if ($info[$value] != $arr[$value]) {
                    $updateData[$value] = $arr[$value];
                }
            }
        }
        if (empty($updateData)) {
            return backarr(0, "无修改数据");
        }
        $row = $m_u->updatebyid($id, $updateData);
        if (empty($row)) {
            return backarr(0, "修改失败");
        }
        return backarr(1, "修改成功", ['id' => $id]);
    }
    /**
     * 验证身份证号
     */
    private function hassfzid($sfzid)
    {
        $m_u = new usermodel();
        $info = $m_u->getinfobysfzid($sfzid);
        return !empty($info);
    }
    /**
     * 验证手机号
     */
    private function hastelno($telno)
    {
        $m_u = new usermodel();
        $info = $m_u->getinfobytelno($telno);
        return !empty($info);
    }
    /**
     * 修改iscompany
     * wj
     * 20220118
     */
    public function updateiscompanybyopenid($arr)
    {
        $result = $this->checkparam(__FUNCTION__, $arr);
        if (1 != $result['status']) {
            return $result;
        }
        $openid = $arr['openid'];
        $m_u = new usermodel();
        $info = $m_u->getinfobyopenid($openid);
        if (empty($info)) {
            return backarr(0, '无用户');
        }
        $m_u->updateiscompanybyopenid($openid, 1);
        return backarr(1, '修改成功', ['id' => $info['id']]);
    }
    /**
     * 获取数据根据openid
     * wj
     * 20220118
     */
    public function getfieldbyopenid($arr)
    {
        $result = $this->checkparam(__FUNCTION__, $arr);
        if (1 != $result['status']) {
            return $result;
        }
        $openid = $arr['openid'];
        $m_u = new usermodel();
        $field = ["id", "user_name", "telno", "gender", "age", "email", "is_active", "is_company", "company_id", "origin", "nation", "address"];
        $info = $m_u->getfieldbyopenid($openid, $field);
        if (empty($info)) {
            return backarr(0, '无用户');
        }
        return backarr(1, '查询成功', $info);
    }
    /**
     * 获取数据根据openid
     * wj
     * 20220118
     */
    public function getfieldbyid($arr)
    {
        $result = $this->checkparam(__FUNCTION__, $arr);
        if (1 != $result['status']) {
            return $result;
        }
        $userid = $arr['userid'];
        $m_u = new usermodel();
        $field = ["id", "user_name", "telno", "gender", "age", "email", "is_active", "is_company", "company_id", "origin", "nation", "address"];
        $info = $m_u->getfieldbyid($userid, $field);
        if (empty($info)) {
            return backarr(0, '无用户');
        }
        return backarr(1, '查询成功', $info);
    }
}
